unsigned char LastDiscrepancy=0;

void InitW1(void)
  {
    #if (W1_Interface<2)
        W1_BitRD=1;
        #if (W1_Interface==0)
            W1_BitWR=1;
          #else
            W1_BitWR=0;
        #endif
    #else
        W1_BitRD=1;
        W1_BitDrive=0;

        W1_BitDPU=0;                     // 1-Wire-Bus auf High ziehen
        Delay_8us();
        W1_BitDPU=1;                     // Der 1-Wire-Bus sollte jetzt High sein
    #endif

    LastDiscrepancy=0;
  }


unsigned char W1_Reset(void)
  {
    bit tmp;

    #if (W1_Interface<2)
        #if (W1_Interface==0)
            W1_BitWR=0;
          #else
            W1_BitWR=1;
        #endif
        Delay_480us();

        #if (W1_Interface==0)
            W1_BitWR=1;
          #else
            W1_BitWR=0;
        #endif
        Delay_66us();
        tmp=W1_BitRD;
        Delay_300us();
     #else
        // Advanced 1-Wire Network Drive
        W1_BitDrive=1;                   // A
        Delay_480us();

        W1_BitDrive=0;                   // B

        W1_BitDPU=0;                     // 1-Wire-Bus auf High ziehen E
        Delay_8us();
        W1_BitDPU=1;                     // Der 1-Wire-Bus sollte jetzt High sein F

        Delay_72us();

        tmp=W1_BitRD;                    // H
        Delay_240us();                   // J

        W1_BitDPU=0;                     // 1-Wire-Bus auf High ziehen K
        Delay_60us();
        W1_BitDPU=1;                     // Der 1-Wire-Bus sollte jetzt High sein L
    #endif

    return tmp;
  }


unsigned char W1_Read_Bit(void)
  {
    unsigned char WBit;

    EA=0;
    #if (W1_Interface<2)
        #if W1_Interface==0
             W1_BitWR=0;
             W1_BitWR=0;
             W1_BitWR=0;
             W1_BitWR=1;
          #else
             W1_BitWR=1;
             W1_BitWR=1;
             W1_BitWR=1;
//             Delay_8us;
             W1_BitWR=0;
        #endif

        Delay_15us();
        WBit=W1_BitRD;
        Delay_60us();
      #else
        // Advanced 1-Wire Network Drive
        W1_BitDrive=1;
        W1_BitDrive=0;                   // BR
        Delay_18us();

        WBit=W1_BitRD;
        if WBit==1
          {
            W1_BitDPU=0;                     // 1-Wire-Bus auf High ziehen D1
            Delay_60us();
            W1_BitDPU=1;                     // Der 1-Wire-Bus sollte jetzt High sein E1
            Delay_45us();
          }
          else
          {
            Delay_45us();
            W1_BitDPU=0;                     // 1-Wire-Bus auf High ziehen F0
            Delay_15us();
            W1_BitDPU=1;                     // Der 1-Wire-Bus sollte jetzt High sein G0
          }
    #endif
    EA=1;
    Delay_45us();     // -2 Takte

    return WBit;
  }


void W1_Write_Bit(unsigned char WBit)
  {
    EA=0;
    #if (W1_Interface<2)
        #if (W1_Interface==0)
            W1_BitWR=0;
          #else
            W1_BitWR=1;
//            Delay_8us();
        #endif
        //Delay_2us();
        _asm
        NOP
        NOP
        NOP
        NOP
        _endasm;
        #if (W1_Interface==0)
            W1_BitWR=(WBit!=0);
          #else
            W1_BitWR=(WBit==0);
        #endif
        Delay_100us();

        #if (W1_Interface==0)
            W1_BitWR=1;
          #else
            W1_BitWR=0;
        #endif
      #else
       // Advanced 1-Wire Network Drive
        W1_BitDrive=1;                   // A
        if (WBit<>0)
          {
            // Eine 1 ausgeben
            Delay_8us();
            W1_BitDrive=0;                   // BR
            Delay_10us();
            W1_BitDPU=0;                     // 1-Wire-Bus auf High ziehen D1
            Delay_60us();
            W1_BitDPU=1;                     // Der 1-Wire-Bus sollte jetzt High sein E1
          }
          else
          {
            // Eine 0 ausgeben
            Delay_60us();
            W1_BitDrive=0;                   // B0
            //Delay_2us();
        _asm
        NOP
        NOP
        NOP
        NOP
        _endasm;
            W1_BitDPU=0;                     // 1-Wire-Bus auf High ziehen C0
            Delay_16us();
            W1_BitDPU=1;                     // Der 1-Wire-Bus sollte jetzt High sein D0
          }
        //Delay_2us();
        _asm
        NOP
        NOP
        NOP
        NOP
        _endasm;
    #endif
    EA=1;
  }


unsigned char W1_Read_Byte(void)
  {
    unsigned char tmp, i;

    tmp=0;
    for (i=0;i<8;i++)
      {
        tmp=tmp>>1;
        if (W1_Read_Bit()>0) tmp=tmp | 0x80;
        Delay_45us();     // -2 Takte
      }
    return tmp;
  }


void W1_Write_Byte(unsigned char WByte)
  {
    unsigned char tmp;
    bit WBit;

    tmp=WByte;
    for (i=0;i<8;i++)
      {
        WBit=tmp & 0x01;
        tmp=tmp>>1;

        W1_Write_Bit(WBit);
      }
    Delay_100us();
  }


unsigned char W1_ROM_Search(unsigned char W1_Buffer[7])
  {
    // Vor dem Start eine ROM_Searchs mu LastDiscrepancy auf 0 gesetzt werden
    // Solange LastDiscrepancy nicht 0 ist, sind noch nicht alle 1-Wire-Devices gefunden

    unsigned char BitA, BitB;
    unsigned char i, j;
    unsigned char Discrepancy;

    if (W1_Reset()==0)                            // Send Reset Signal on 1-Wire Bus
      {
        // Presence Signal Detected
        W1_Write_Byte(Search_ROM);               // Send Search Command (F0) on 1-Wire Bus
        Discrepancy=0;                           // Set Discrepancy Marker to "0"
        for(i=0;i<8;i++)
          {
            for(j=0;j<8;j++)
              {
                W1_Buffer[i]=W1_Buffer[i]>>1;
                BitA=W1_Read_Bit();              // Read Bit "A" From 1-Wire Bus
                BitB=W1_Read_Bit();              // Read Bit "B" From 1-Wire Bus
                if (BitA>0)
                  {
                    if (BitB!=0)
                      {
                        LastDiscrepancy=0;
                        return Data_ERR;
                      }
                     else
                      {
                        W1_Buffer[i]=W1_Buffer[i] | 0x80;        // Set 1
                        W1_Write_Bit(BitA);                      // Send Bit Index To 1-Wire Bus
                      }
                  }
                 else
                  {
                    if (BitB!=0)
                      {
                        W1_Buffer[i]=W1_Buffer[i] & 0x7F;        // Set 0
                        W1_Write_Bit(BitA);                      // Send Bit Index To 1-Wire Bus
                      }
                     else
                      {
                        //4444444444444444444444444
                        if ((i*8+j+1)==LastDiscrepancy)
                          {
                            // 55555555555555555555555555555555
                            // ROM Bit Index = Last Discrepancy
                            BitA=1;
                            W1_Buffer[i]=W1_Buffer[i]|0x80;         // Set 1
                            W1_Write_Bit(BitA);                      // Send Bit Index To 1-Wire Bus
                          }
                         else
                          {
                            if ((i*8+j+1)>LastDiscrepancy)
                              {
                                //666666666666666666666
                                // ROM Bit Index > Last Discrepancy
                                BitA=0;
//                                W1_Buffer[i]=W1_Buffer[i]&0x7F;    // Set 0
                                Discrepancy=(i*8+j+1);
                                W1_Write_Bit(BitA);                  // Send Bit Index To 1-Wire Bus
                              }
                             else
                              {
                                // ROM Bit Index < Last Discrepancy
                                if (W1_Buffer[i]&(2^j)==0)
                                  {
                                    //999999999999999999999999999999999
                                    // ROM Bit Index = 0
                                    BitA=0;
                                    Discrepancy=(i*8+j+1);
                                  }
                                W1_Write_Bit(BitA);                  // Send Bit Index To 1-Wire Bus
                              }
                          }
                      }
                  }
              }
          }
        LastDiscrepancy=Discrepancy;
      }
     else
      {
        // No Presence Signal Detected
        LastDiscrepancy=0;
        return Presence_ERR;
      }

    return 1;
  }
////
////
////
////
////    //W1_Buffer wird in DPTR bergeben
////    A=WByte;
////
////    _asm
//////                    MOV       R0,#W1_Data_ID
////                    MOV       R0,DPL          // Buffer sollte im internen RAM liegen
////                    MOV       R5,A
////
////                    // Send Reset Signal on 1-Wire Bus
////                    CALL      W1_Reset
////
////                    MOV       A,#Presence_ERR
////                    // Presence Signal Detected ?
////                    JC        W1_ROM_Search7                // No
////                    // => Yes// Send Search Command (F0) on 1-Wire Bus
////                    MOV       A,#Search_ROM
////                    CALL      W1_Write_Byte
////
////                    MOV       R3,#Last_Device
////                    MOV       R4,#9 * 8
////W1_ROM_Search1:     MOV       R6,#8
////
////W1_ROM_Search2:     // Read Bit "A" From 1-Wire Bus
////                    CALL      W1_Read_Bit
////                    MOV       F0,C
////                    // Read Bit "B" From 1-Wire Bus
////                    CALL      W1_Read_Bit
////                    // Bit A=0 ?
////                    JNB       F0,W1_ROM_Search3             // Yes
////                    // => Bit A=1// BIT B=0 ?
////                    JNC       W1_ROM_Search5                // Yes
////                    // => Bit B = 1
////                    MOV       A,#Data_ERR
////
////                    RET
////
////W1_ROM_Search3:     // => Bit A=0// Bit B=1 ?
////                    JC        W1_ROM_Search5                // Yes
////                    // => Bit B = 0
////                    // ROM Bit Index = Last Discrepancy ?
////                    MOV       A,R4
////                    SUBB      A,R5
////                    JZ        W1_ROM_Search6                // Yes
////                    // => No//  ROM Bit Index > Last Discrepancy ?
////                    JNC       W1_ROM_Search4                // Yes
////                    // ROM Bit Index = 0 ?
////                    MOV       A,@R0
////                    JNB       ACC.0,W1_ROM_Search6
////                    // => No
////                    // Set Discrepancy Marker to ROM Bit Index
////
////W1_ROM_Search4:     // Set ROM Bit Index To "0"
////                    CLR       C
////                    // Set Discrepancy Marker To ROM Bit Index
////                    MOV       A,R4
////                    MOV       R3,A
////
////W1_ROM_Search5:     // => Bit A=0 und Bit B=1 oder Bit A=1 und Bit B=0
////                    CPL       C
////
////W1_ROM_Search6:     MOV       A,@R0
////                    // Set ROM Bit Index to Bit "A"
////                    RRC       A
////                    MOV       @R0,A
////                    // Send Bit Index To 1-Wire Bus
////                    RLC       A
////                    CALL      W1_Write_Bit
////                    // Increment ROM Bit Index
////                    DEC       R4
////                   // Is ROM Bit Index >64
////                    DJNZ      R6,W1_ROM_Search2             // No
////
////                    INC       R0
////                    DJNZ      R4,W1_ROM_Search1             // No
////                    // => Yes
////                    MOV       A,R3
////
////W1_ROM_Search7:
////    _endasm;
////
////    return A;
////  }

//******************************************************************************
//* Temperatur lesen, ID wird nicht bercksichtigt.                            *
//*                                                                            *
//* Input:                                                                     *
//* Output: A                                                                  *
//* Used:   A, R0, R1, R2, R3                                                  *
//* Stack:  2+                                                                 *
//******************************************************************************
int ReadTemperatur(void)
  {
    unsigned char i;
    unsigned char W1_Buffer[7];

    W1_Reset();
    W1_Write_Byte(Skip_ROM);
    W1_Write_Byte(Read_Scratchpad);

    for(i=0;i<8;i++)
      {
        W1_Buffer[i]=W1_Read_Byte();
      }
    if (W1_Buffer[1]!=0)
        return -W1_Buffer[0];
      else
        return W1_Buffer[0];

  }

void ConvertTemperatur(void)
  {
    W1_Reset();
    W1_Write_Byte(Skip_ROM);
    W1_Write_Byte(Convert);
  }

////******************************************************************************
////* Ist-Temperaturen lesen, ID wird bercksichtigt                             *
////*                                                                            *
////* Input:  W1_Data_ID                                                         *
////* Output: A                                                                  *
////* Used:   A, R0, R1, R2, R3                                                  *
////* Stack:  2+                                                                 *
////******************************************************************************
//ReadTemperaturID:   // ID senden
//                    MOV       R1,#W1_Data_ID
//                    MOV       R0,#08h
//ReadTemperaturID2:  MOV       A,R0
//                    CALL      W1_Write_Byte
//                    INC       R1
//                    DJNZ      R0,ReadTemperaturID2
//
//                    // Temperatur lesen
//                    MOV       A,#Read_Scratch
//                    CALL      W1_Write_Byte
//
//                    MOV       R0,#08h
//                    MOV       R1,#W1_Data
//
//ReadTemperaturID3:  CALL      W1_Read_Byte
//                    MOV       @R1,A
//                    INC       R1
//                    DJNZ      R0,ReadTemperaturID3
//
//                    // Temperatur konvertieren
//                    MOV       A,W1_Data+1
//
//                    JNB       ACC.0,ReadTemperaturID4
//
//                    MOV       A,W1_Data
//                    CPL       A
//                    INC       A
//                    ORL       A,#80h                        // Vorzeichen auf MSB bertragen
//                    JMP       ReadTemperaturID5
//
//ReadTemperaturID4:  MOV       A,W1_Data
//                    ANL       A,#7Fh                        // Vorzeichen auf MSB bertragen
//
//ReadTemperaturID5:  RET
//
////******************************************************************************
////* Temperatur auf 1/2 Grad genau lesen                                        *
////*                                                                            *
////* Input:  W1_Data_ID                                                         *
////* Output: A                                                                  *
////* Used:   A                                                                  *
////* Stack:  2                                                                  *
////******************************************************************************
//CalcTemp1_2:        MOV       A,W1_Data+1
//
//                    JNB       ACC.0,CalcTemp1_2_2
//
//                    MOV       A,W1_Data
//                    CPL       A
//                    INC       A
//                    ORL       A,#80h                        // Vorzeichen auf MSB bertragen
//                    JMP       CalcTemp1_2_End
//
//CalcTemp1_2_2:      MOV       A,W1_Data
//                    ANL       A,#7Fh                        // Vorzeichen auf MSB bertragen
//
//CalcTemp1_2_End:
//                    RET
//
////******************************************************************************
////* Temperatur auf 1/10 Grad genau lesen                                       *
////* B enthlt beim Aufruf den FamilyCode des Sensors                           *
////* Rckgabe der Temperatur: Low-Byte in A, High-Byte in B                     *
////*                                                                            *
////* Input:  W1_Data, B                                                         *
////* Output: A, B                                                               *
////* Used:   A, B, R0, DPTR                                                     *
////* Stack:  3                                                                  *
////******************************************************************************
//CalcTemp1_10:       MOV       A,B
//                    CJNE      A,#ROMCodeDS18B20,CalcTemp1_10_1
//                    JMP       CalcTemp1_10_5
//
//CalcTemp1_10_1:     MOV       A,W1_Data+1
//
//                    JNB       ACC.0,CalcTemp1_10_2
//
//                    MOV       A,W1_Data
//                    CPL       A
//                    INC       A
//                    ANL       A,#0FEh                       // 0,5 lschen
//                    MOV       B,#05h                        // mit 5 multplizieren, damit es als
//                    MUL       AB                            // Dezimalzahl ausgegeben werden kann
//                    ORL       B,#80h                        // Vorzeichen auf MSB bertragen
//                    MOV       R0,A                          // fr spter aufheben
//                    JMP       CalcTemp1_10_3
//
//CalcTemp1_10_2:     MOV       A,W1_Data
//                    ANL       A,#0FEh                       // 0,5 lschen
//                    MOV       B,#05h                        // mit 5 multplizieren, damit es als
//                    MUL       AB                            // Dezimalzahl ausgegeben werden kann
//                    MOV       R0,A                          // fr spter aufheben
//
//CalcTemp1_10_3:     MOV       A,W1_Data+6                   // den Korrektur-Wert holen
//                    MOV       DPTR,#TabelleDS18S20          // in der Tabelle den Dezimalwert dazu holen
//                    MOVC      A,@A+DPTR
//                    JB        ACC.7,KorrekturNegativ        // Dezimalwert > 128 subbtrahieren
//
//                    ADD       A,R0                          // Dezimalwert addieren
//                    XCH       A,B
//                    ADDC      A,#00h                        // bertrag bercksichtigen
//                    XCH       A,B
//                    JMP       KorrekturEnd
//
//KorrekturNegativ:   CLR       ACC.7                         // einen Korrekturwert subtrahieren
//                    XCH       A,R0
//                    CLR       C
//                    SUBB      A,R0                          // Dezimalwert subtrahieren
//                    XCH       A,B
//                    SUBB      A,#00h                        // bertrag bercksichtigen
//                    XCH       A,B
//
//KorrekturEnd:       PUSH      ACC                           // Ergebnis prfen
//                    MOV       A,B
//                    ANL       A,#3Ch                        // Vorzeichen und erlaubte Werte ausmaskieren +-102,3C
//                    JZ        KorrekturEnde
//                    POP       ACC                           // Wert ist auerhalb des mglichen Bereichs
//                    CLR       A
//                    MOV       B,A
//                    PUSH      ACC
//
//KorrekturEnde:      POP       ACC
//
//                    RET
//
//CalcTemp1_10_5:     MOV       B,W1_DATA
//                    MOV       A,W1_Data+1
//                    JNB       ACC.7,CalcTemp1_10_6
//                    XCH       A,B                           // 1er Komplement bilden
//                    CPL       A
//                    ADD       A,#01h
//                    XCH       A,B
//                    CPL       A
//                    ADDC      A,#00h
//                    ORL       A,#80h                        // Vorzeichen auf MSB bertragen
//                    MOV       W1_Data+1,A
//
//CalcTemp1_10_6:     // B = Low-Byte// A und W1_Data+1 = High-Byte
//                    MOV       A,B
//                    MOV       R0,#W1_Data+1
//                    XCHD      A,@R0
//                    SWAP      A
//
//                    MOV       B,#10d                        // mit 5 multplizieren, damit es als
//                    MUL       AB                            // Dezimalzahl ausgegeben werden kann
//                    MOV       R0,A                          // fr spter aufheben
//
//CalcTemp1_10_7:     MOV       A,W1_DATA+1                   // den Korrektur-Wert holen
//                    MOV       C,ACC.7                       // Vorzeichen verschieben
//                    MOV       B.7,C
//                    ANL       A,#0Fh
//                    MOV       DPTR,#TabelleDS18B20          // in der Tabelle den Dezimalwert dazu holen
//                    MOVC      A,@A+DPTR
//
//                    ADD       A,R0                          // Dezimalwert addieren
//                    XCH       A,B
//                    ADDC      A,#00h                        // bertrag bercksichtigen
//                    XCH       A,B
//                    JMP       KorrekturEnd
//

//******************************************************************************
//* Schaltet den Ausgang eines DS2405 um und gibt den aktuellen Wert zurck    *
//*                                                                            *
//* Input:  W1_Data_ID                                                         *
//* Output: C                                                                  *
//* Used:   A, R0, R1, R2, R3                                                  *
//* Stack:  4+                                                                 *
//******************************************************************************
unsigned char ToggleDS2405(unsigned char ROM[7])
  {
    unsigned char i;

    W1_Reset();
    W1_Write_Byte(Match_ROM);
    for (i=0;i<8;i++)
      {
        W1_Write_Byte(ROM[i]);
      }
    Delay_45us();

    return W1_Read_Bit();
  }

//******************************************************************************
//* Schaltet den Ausgang eines DS2405 auf den Wert in C                        *
//* es wird nur 2 Mal versucht den Wert zu ndern                              *
//*                                                                            *
//* Input:  W1_Data_ID, C                                                      *
//* Output:                                                                    *
//* Used:   A, R0, R1, R2, R3                                                  *
//* Stack:  5+                                                                 *
//******************************************************************************
void WriteDS2405(unsigned char ROM[8], unsigned char Value)
  {
    if (ToggleDS2405(ROM)!=Value)
      ToggleDS2405(ROM);
  }

//******************************************************************************
//* Liest den Wert des Eingangs eines DS2405 in C                              *
//*                                                                            *
//* Input:  W1_Data_ID                                                         *
//* Output: C                                                                  *
//* Used:   A, R0, R1, R2, R3                                                  *
//* Stack:  5+                                                                 *
//******************************************************************************
unsigned char ReadDS2405(unsigned char ROM[7])
  {
    ToggleDS2405(ROM);
    return ToggleDS2405(ROM);
  }

////******************************************************************************
////* Berechnung der CRC-Checksumme                                              *
////*                                                                            *
////* Umsetzung aus AVR-Code von Peter Dannegger                                 *
////*                                                                            *
////* Input:  A, CRC                                                             *
////* Output: CRC                                                                *
////* Used:                                                                      *
////* Stack:  2                                                                  *
////******************************************************************************
//
////          MOV       CRC,#00h
////ByteEmpf: Byte in A setzen
////          CALL      CRC_0
////          DJNZ      X,ByteEmpf
//
//
////CRC_0:    XOR       A,CRC
////
////          MOV       CRC,#00h
////          JB        ACC.0,CRC_1
////          MOV       CRC,#5Eh
////
////CRC_1:    JB        ACC.1,CRC_2
////          XOR       CRC,#0BCh
////
////CRC_2:    JB        ACC.2,CRC_3
////          XOR       CRC,#61h
////
////CRC_3:    JB        ACC.3,CRC_4
////          XOR       CRC,#0C2h
////
////CRC_4:    JB        ACC.4,CRC_5
////          XOR       CRC,#9Dh
////
////CRC_5:    JB        ACC.5,CRC_6
////          XOR       CRC,#23h
////
////CRC_6:    JB        ACC.6,CRC_7
////          XOR       CRC,#46h
////
////CRC_7:    JB        ACC.7,CRC_8
////          XOR       CRC,#8Ch
////
////CRC_8:    RET
//
//
//// Tabelle fr die Korrektur der Temperatur fr den DS18S20
//TabelleDS18S20:     DB 07h,06h,06h,05h,04h,04h,03h,02h,02h,01h,01h,00h,81h,81h,82h,82h,83h
//
//// Tabelle fr die Korrektur der Temperatur fr den DS18B20
//TabelleDS18B20:     DB 00h,01h,01h,02h,02h,03h,04h,04h,05h,06h,06h,07h,07h,08h,08h,09h
