//*****************************************************************************
// EEPROM
__xdata __at (0x0000) unsigned char EEProm[];

void InitEEProm(void)
  {
    EETIM=120;                     // Zeit frs programmieren des EEPROM's setzen
  }                  

// Warten bis letztes schreiben ins EEProm abgeschlossen ist                  
void EEPromBusy(void)
  {
    while ((EECON & 0x01)>0);
  }                    

// Schreiben ins EEProm beginnen und EEProm disablen                          
void EEPromWrite(void)
  {         
    EECON=0x52;                    // Speichern ins EEPROM starten
    EECON=0xA0;                    // und EEPROM ausschalten
  }                

// EEProm enablen                                                             
void EEPromEnable(void)
  {
    EECON=0x02;                    // EEPROM einschalten
  }

// EEProm disablen                                                             
void EEPromDisable(void)
  {
    EECON=0x00;                    // EEPROM ausschalten
  }                

void WriteEEProm(unsigned char *Adresse, __data unsigned char Wert)
  {
    EEPromBusy();
    EEPromEnable();
    *Adresse=Wert;
    EEPromWrite();
  } 
  
unsigned char ReadEEProm(unsigned char *Adresse)  
  {
    unsigned char tmp;
    
    EEPromBusy();
    EEPromEnable();
    tmp=*Adresse;
    EEPromDisable();
    
    return tmp;
  }

// Ende EEPROM
//*****************************************************************************
