//*****************************************************************************
// Edit
unsigned char *CurrentAddress ;
unsigned char CurrentValue[5];    // (Stunde, Minute, Jahr, Monat, Tag)
bit EditActive=0;
unsigned char EditMin;
unsigned char EditMax;
unsigned char EditPos;
unsigned char EditTyp;  // 1 Byte fr die Art der Eingabe
                        // 0 => nur Zahl
                        // 1 => C
                        // 2 => Uhrzeit
                        // 3 => Uhrzeit und Datum
                        // 4 => Displayhelligkeit (Balkenanzeige)
                        // 5 => Anzahl Sekunden
                        // 6 => Anzahl Minuten
unsigned char Step;

void ShowEditValue(void)
  {
    unsigned char i;
    
    ClearScreen();
    SetCursor(15,2);
    switch (EditTyp)
      {
           case 0: puts(CStr(CurrentValue[0]));
                   break;
           case 1: puts(CStr(CurrentValue[0])+'C');
                   break;
           case 2: if (EditPos==0) invers=1;
                   puts(CStr(CurrentValue[0]));       // Stunden anzeigen
                   invers=0;
                   
                   puts(":");  
                     
                   if (EditPos==1) invers=1;
                   MinLength=2;
                   puts(CStr(CurrentValue[1]));       // Minuten anzeigen (schn wenn das 2 stellig ginge)
                   MinLength=0;
                   invers=0;
                   break;
           case 3: if (EditPos==0) invers=1;
                   puts(CStr(CurrentValue[0]));       // Stunden anzeigen
                   invers=0;
                   
                   puts(":");  
                     
                   if (EditPos==1) invers=1;
                   puts(CStr(CurrentValue[1]));       // Minuten anzeigen (schn wenn das 2 stellig ginge)
                   invers=0;
                   
                   break;
           case 4: SetCursor(10,2);
                   WriteByte(0xFF);
                   for (i=EditMin;i<CurrentValue[0]*Step;i++)
                     {
                       WriteByte(0xFF);
                     }  
                   for (i=CurrentValue[0]*Step;i<EditMax*Step;i++)
                     {
                       WriteByte(0x81);
                     }  
                   WriteByte(0xFF);
                   
                   SetCursor(15+EditMax/2,3);
                   puts(CStr(CurrentValue[0]));
                   SetContrast(CurrentValue[0]);
                   break;
           case 5: puts(CStr(CurrentValue[0])+'s');
                   break;
           case 6: puts(CStr(CurrentValue[0])+'min');
                   break;
      }     
  }
  
void EditEEProm(unsigned char *Address, unsigned char Typ, unsigned char Min, unsigned char Max)
  {
    CurrentAddress=Address;
    CurrentValue[0]=ReadEEProm(Address);
    EditTyp=Typ;
    EditPos=0;
    switch (EditTyp)
      {
           case 0: EditMin=Min; 
                   EditMax=Max;
                   break;
           case 1: EditMin=70; 
                   EditMax=255;
                   break;
           case 2: CurrentValue[1]=ReadEEProm(Address+1);
                   EditMin=0; 
                   EditMax=23;
                   break;
           case 3: CurrentValue[1]=ReadEEProm(Address+1);  // Minute
                   CurrentValue[2]=ReadEEProm(Address+4);  // Jahr
                   CurrentValue[3]=ReadEEProm(Address+3);  // Monat
                   CurrentValue[4]=ReadEEProm(Address+2);  // Tag
                   EditMin=0; 
                   EditMax=23;
                   break;
           case 4: EditMin=0; 
                   EditMax=31;
                   Step=1;
                   break;
           case 5: 
                   EditMin=0; 
                   EditMax=59;
                   break;
           case 6: 
                   EditMin=0; 
                   EditMax=59;
                   break;
      }     
    if (CurrentValue[0]>EditMax) CurrentValue[0]=EditMax;
    if (CurrentValue[0]<EditMin) CurrentValue[0]=EditMin;
    ShowEditValue();
    EditActive=1;
  }

void SaveEditValue(void)
  {
    switch (EditTyp)
      {
           case 2: if (EditPos==0) 
                     {
                       EditMin=0; 
                       EditMax=59;
                       EditPos=1;
                       CurrentValue[EditPos]=ReadEEProm(CurrentAddress+EditPos);
                       if (CurrentValue[EditPos]>EditMax) CurrentValue[EditPos]=EditMax;
                       if (CurrentValue[EditPos]<EditMin) CurrentValue[EditPos]=EditMin;
                       ShowEditValue();
                     }
                    else
                     {    
                       WriteEEProm(CurrentAddress+0,CurrentValue[0]);
                       WriteEEProm(CurrentAddress+1,CurrentValue[1]);
                       EditActive=0;
                       Menue_Show();
                     }
                   break;
           case 3: switch (EditPos) 
                     {
                          case 0: EditMin=0; 
                                  EditMax=59;
                                  break; 
                          case 1: EditMin=0; 
                                  EditMax=59;
                                  break; 
                          case 2: EditMin=0; 
                                  EditMax=99;
                                  break; 
                          case 3: EditMin=0; 
                                  EditMax=12;
                                  break; 
                          case 4: EditMin=0; 
                                  EditMax=30;
                                  break; 
                     }
                   if (EditActive==0)
                     {
                       WriteEEProm(CurrentAddress+0,CurrentValue[0]);  // Stunde
                       WriteEEProm(CurrentAddress+1,CurrentValue[1]);  // Minute
                       WriteEEProm(CurrentAddress+4,CurrentValue[2]);  // Jahr
                       WriteEEProm(CurrentAddress+3,CurrentValue[3]);  // Monat
                       WriteEEProm(CurrentAddress+2,CurrentValue[4]);  // Tag
                       EditActive=0;
                       Menue_Show();
                     }
                    else
                     {
                       EditPos=EditPos+1;
                       CurrentValue[EditPos]=ReadEEProm(CurrentAddress+EditPos);
                       if (CurrentValue[EditPos]>EditMax) CurrentValue[EditPos]=EditMax;
                       if (CurrentValue[EditPos]<EditMin) CurrentValue[EditPos]=EditMin;
                       ShowEditValue();
                     }    
                   break;
           default: 
                   WriteEEProm(CurrentAddress+EditPos,CurrentValue[0]);
                   EditActive=0;
                   Menue_Show();
                   break;
      }     
  }
  
void AbbortEdit(void)
  {
    EditActive=0;
    Menue_Show();
  }    
      
void IncEditValue(void)
  {
    if (CurrentValue[EditPos]<EditMax) 
      {
        CurrentValue[EditPos]=CurrentValue[EditPos]+1;
        ShowEditValue();
      }  
  }         

void DecEditValue(void)
  {
    if (CurrentValue[EditPos]>EditMin) 
      {
        CurrentValue[EditPos]=CurrentValue[EditPos]-1;
        ShowEditValue();
      }  
  }         

void IncBigEditValue(void)
  {
    if ((CurrentValue[EditPos]+10)<EditMax)
      {
        CurrentValue[EditPos]=CurrentValue[EditPos]+10;
        ShowEditValue();
      }
     else
      {
        if (CurrentValue[EditPos]!=EditMax)
          {
            CurrentValue[EditPos]=EditMax;
            ShowEditValue();
          }  
      }       
  }         

void DecBigEditValue(void)
  {
    if ((CurrentValue[EditPos]-10)>EditMin)
      {
        CurrentValue[EditPos]=CurrentValue[EditPos]-10;
        ShowEditValue();
      }
     else
      {
        if (CurrentValue[EditPos]!=EditMin)
          {
            CurrentValue[EditPos]=EditMin;
            ShowEditValue();
          }  
      }       
    ShowEditValue();
  }         

// Ende Edit
//*****************************************************************************
