void InitIIC(void)
  {
    IIC_SDA=1;
    IIC_SCL=1;
  }

//******************************************************************************
//* Start einer bertragung                                                    *
//*                                                                            *
//******************************************************************************
void IICStart(void)
  {
    IIC_SDA=1;
    IIC_SCL=1;
    Delay_IICTW();
    IIC_SDA=0;
  }

//******************************************************************************
//* Ende eine bertragung                                                      *
//*                                                                            *
//******************************************************************************
void IICStop(void)
  {
    Delay_IICTW();
    IIC_SDA=0;
    Delay_IICTW();
    IIC_SCL=1;
    Delay_IICTW();
    Delay_IICTW();
    Delay_IICTW();
    Delay_IICTW();
    IIC_SDA=1;
  }

//******************************************************************************
//* Senden eines Bytes                                                         *
//*                                                                            *
//******************************************************************************
unsigned char IICSend(unsigned char IICByte)
  {
    unsigned char tmp;

    tmp=IICByte;
    for (i=0;i<8;i++)
      {
        IIC_SCL=0;
        Delay_IICTW();
        IIC_SDA=tmp & 0x01;
        Delay_IICTW();
        IIC_SCL=1;
        Delay_IICTSCL();
        IIC_SCL=0;
        Delay_IICTSCL();
        tmp=tmp>>1;
      }
    IIC_SDA=1;                   // fr Acknowledge auf High
    Delay_IICTW();
    IIC_SCL=1;
    Delay_IICTSCL();

    return IIC_SDA;             // Acknowledge lesen
  }

//******************************************************************************
//* Empfangen eines Bytes                                                      *
//*                                                                            *
//******************************************************************************
unsigned char IICRead(bit IICAck)
  {
    unsigned char tmp=0;

    for (i=0;i<8;i++)
      {
        IIC_SCL=0;
        Delay_IICTW();
        IIC_SDA=1;
        Delay_IICTW();
        IIC_SCL=1;
        Delay_IICTSCL();
        if (IIC_SDA) tmp=tmp | 0x80;
        tmp=tmp>>1;
        IIC_SCL=0;
        Delay_IICTSCL();
      }
      IIC_SDA=IICAck;            // Acknowledge senden
      Delay_IICTW();
      IIC_SCL=1;
      Delay_IICTSCL();
      IIC_SCL=0;
      Delay_IICTSCL();

      return tmp;
  }

//******************************************************************************
//*                                                                            *
//*   Unterprogramm schreibt oder liest                                        *
//*        (abhngig ob IIC-Bus-Adresse gerade oder ungerade ist)              *
//*      die IIC-Bus-Daten (IICDat) der IIC-Bus-Adresse (IICAdr)               *
//*                                                                            *
//******************************************************************************
unsigned char IICBus(unsigned char IICAdr, unsigned char IICDat)
  {
    unsigned char tmp;

    IICStart();
    IICSend(IICAdr);
    if ((IICAdr & 0x01) == 0)
      {
        tmp=IICRead(0);
      }
     else
      {
        tmp=IICSend(IICDat);
      }
     IICStop();

     return tmp;
  }

//******************************************************************************
//*                                                                            *
//*   Unterprogramm schreibt oder liest                                        *
//*        (abhngig ob IIC-Bus-Adresse gerade oder ungerade ist)              *
//*      die IIC-Bus-Daten (IICDat) der Sub-Adresse (IICSub)                   *
//*          IIC-Bus-Adresse (IICAdr)                                          *
//*                                                                            *
//******************************************************************************
unsigned char IICMBus(unsigned char IICAdr, unsigned char IICSub, unsigned char IICDat)
  {
    unsigned char tmp;

    IICStart();
    IICSend(IICAdr & 0xFE);                  // A0 auf Low setzen da Memory-Adresse geschrieben wird
    IICSend(IICSub);                                                       ;

    if ((IICAdr & 0x01) == 0)
      {
        IICSend(IICAdr);
        tmp=IICRead(1);                     // kein Acknowledge senden
      }
     else
      {
        tmp=IICSend(IICDat);
      }
     IICStop();

     return tmp;
  }

