// Functions-Prototypen
void InitIIC(void);
unsigned char IICBus(unsigned char IICAdr, unsigned char IICDat);
unsigned char IICMBus(unsigned char IICAdr, unsigned char IICSub, unsigned char IICDat);
void IICStart(void);
void IICStop(void);
unsigned char IICSend(unsigned char IICByte);
unsigned char IICRead(bit IICAck);

void Delay_IICTW(void);
void Delay_IICTSCL(void);


#include "IIC.c"


// X=12000 / t(s)
#ifndef DelayA
  #define   DelayA              4                           // Zyklen fr Aufruf
#endif
#define   WaitTW              (Xtal+2999)/3000*X2Set/2      //  100kHz
#define   WaitSCL             (Xtal+2399)/2400*X2Set/2      //  100kHz

//******************************************************************************
//* Zeitschleifen                                                              *
//*                                                                            *
//******************************************************************************
void Delay_IICTW(void)
  {
    _asm
         #if (WaitTW<DelayA)
          #else
             MOV    DPL,#WaitTW-DelayA
loopIICTW:   DJNZ   DPL,loopIICTW
         #endif
    _endasm;
  }

void Delay_IICTSCL(void)
  {
    _asm
         #if (WaitSCL<DelayA)
          #else
             MOV    DPL,#WaitSCL-DelayA
loopIICTSCL: DJNZ   DPL,loopIICTSCL
         #endif
    _endasm;
  }
