#include <string.h>
#include <at89c51ed2.h>
//#include <mcs51reg.h>


#define LED1 P1_1
#define ON 0
#define OFF 1

// 1Wire
#define X2Set        1

// ENC26J80
#define CS_ETH       P3_2

// Experementierboard
#define Xtal         22118
// Nokia Display
#define CS_Disp      P1_4
#define DC           P1_3
//#define DisplayType3410 1

// 1Wire
#define W1_Interface 1
#if (W1_Interface==0)
#define W1_Bit       P1_0
#else
#define W1_Bit       P2_0
#define W1_BitWR     P1_0
#endif

// IIC-Bus
#define IIC_SCL      P1_3
#define IIC_SDA      P1_2
#define IntIIC       P1_1

//// Platine
//#define Xtal         11059
//// Nokia Display
//#define SPI_Interface 1
//#define SPI_CLK      P1_7
//#define SPI_DIN      P1_6
//#define DC           P1_5
//#define CS_Disp      P1_4
//
//#define Ton          P3_5
//
//// IIC-Bus
//#define IIC_SCL      P1_1
//#define IIC_SDA      P1_2
//#define IntIIC       P3_3
//
//// 1Wire
//#define W1_Interface 0
//#define W1_Bit       P1_0

#define SensorCount         8
#define PortCount           8

// externer Speicher (EEPROM)
#define TempTag             0x00                         // 1 Byte fr Temperatur bei Tag
#define TempAbwesend        0x01                         // 1 Byte fr Temperatur bei Abwesenheit
#define TempNacht           0x02                         // 1 Byte fr Temperatur bei Nacht
#define HeizungsModus       0x03                         // 1 Byte fr die Anfangs-Adresse der Temperaturen fr den Modus der ausgewhlt wurde

#define ArbeitTag1          0x04                         // 2 Byte fr Stunde und Minute fr Beginn Tag bei Arbeit/Wochentag
#define ArbeitAbwv1         0x06                         // 2 Byte fr Stunde und Minute fr Beginn Abwesend bei Arbeit/Wochentag
#define ArbeitAbwb1         0x08                         // 2 Byte fr Stunde und Minute fr Ende Abwesend bei Arbeit/Wochentag
#define ArbeitNacht1        0x0A                         // 2 Byte fr Stunde und Minute fr Beginn Nacht bei Arbeit/Wochentag
#define ArbeitTag2          0x0C                         // 2 Byte fr Stunde und Minute fr Beginn Tag bei Arbeit/Wochentag
#define ArbeitAbwv2         0x0E                         // 2 Byte fr Stunde und Minute fr Beginn Abwesend bei Arbeit/Wochenende
#define ArbeitAbwb2         0x10                         // 2 Byte fr Stunde und Minute fr Ende Abwesend bei Arbeit/Wochenende
#define ArbeitNacht2        0x12                         // 2 Byte fr Stunde und Minute fr Beginn Nacht bei Arbeit/Wochenende

#define UrlaubTag1          0x14                         // 2 Byte fr Stunde und Minute fr Beginn Tag bei Urlaub/Wochentag
#define UrlaubAbwv1         0x16                         // 2 Byte fr Stunde und Minute fr Beginn Abwesend bei Urlaub/Wochentag
#define UrlaubAbwb1         0x18                         // 2 Byte fr Stunde und Minute fr Ende Abwesend bei Urlaub/Wochentag
#define UrlaubNacht1        0x1A                         // 2 Byte fr Stunde und Minute fr Beginn Nacht bei Urlaub/Wochentag
#define UrlaubTag2          0x1C                         // 2 Byte fr Stunde und Minute fr Beginn Tag bei Urlaub/Wochenende
#define UrlaubAbwv2         0x1E                         // 2 Byte fr Stunde und Minute fr Beginn Abwesend bei Urlaub/Wochenende
#define UrlaubAbwb2         0x20                         // 2 Byte fr Stunde und Minute fr Ende Abwesend bei Urlaub/Wochenende
#define UrlaubNacht2        0x22                         // 2 Byte fr Stunde und Minute fr Beginn Nacht bei Urlaub/Wochenende

#define TempHysterese       0xF0                         // 1 Byte fr die Hysterese der Solltemperatur
#define NachlaufPumpe       0xFC                         // 1 Byte fr die Nachlaufzeit der Pumpe in Minuten
#define HeizungMinEin       0xFD                         // 1 Byte fr die Mindestzeit die die Heizung eingeschaltet sein mu, bevor Sie wieder ausgeschaltet wird
#define HeizungMinAus       0xFE                         // 1 Byte fr die Mindestzeit die die Heizung ausgeschaltet sein mu, bevor Sie wieder eingeschaltet wird
#define Vop                 0xFF                         // 1 Byte fr die Displayhelligkeit

#define SensorAddress       0x400                        // x64 Bit fr die ID's der Temperatur-Sensoren
#define SensorAddressEnd    SensorAddress+SensorCount*8

#define PortAddress         0x500                        // x64 Bit fr die ID's der Port-Bausteine
#define PortAddressEnd      PortAddress+PortCount*8


char str1[10];

unsigned int i;

#define AnzahlTasten 4

unsigned char TastenZeit[AnzahlTasten]={0,0,0,0,0,0,0,0};               // Zhler fr die Dauer des Tastendrucks
unsigned char Taste=0;

#define Taste_OK 1
#define Taste_Abbruch 2
#define Taste_Hoch 4
#define Taste_Runter 3
#define Taste_Gehalten 8


#include "SPI.c"
#include "IIC.h"
#include "Nokia.c"
#include "StdOut.c"
#include "1Wire.h"
#include "enc28j60.c"
#include "DateTime.c"
#include "EEPROM.c"

void W1AktivSensor(unsigned char MenuePos);

#include "Men.h"
#include "Edit.h"

//*****************************************************************************
// Funktionen die vom Men aufgerufen werden

void test1(unsigned char MenuePos)
  {
    EditEEProm(EEProm,2,20,200);
  }

void test2(unsigned char MenuePos)
  {
    EditEEProm(EEProm,4,0,0);
  }

void test3(unsigned char MenuePos)
  {
    ClearScreen();
    puts(CStr(MenuePos));
  }
  
void W1SearchAll (unsigned char MenuePos)
  {
    unsigned char W1_Buffer[7];
    
    // Anzeige lschen
    ClearScreen();
    
    for(i=0;i<8;i++)
      {
        W1_Buffer[i]=0;
      }

    LastDiscrepancy=0;
    do
      {
        W1_ROM_Search(W1_Buffer);

        for(i=8;i>0;i--)
          {
            puts(" ");
            puts(Hex(W1_Buffer[i-1]));
          }
        puts(CRLF);
      }
    while (LastDiscrepancy>0);
  }

void W1AktivSensor(unsigned char MenuePos)
  {
    unsigned char *Adress;
    
    Adress=EEProm+SensorAddress+MenuePos*8;
    if (Adress<(EEProm+SensorAddressEnd))
      {
        if (ReadEEProm(Adress)!=0x00)                 
          {
            // Sensor-ID ist gespeichert
            WriteByte(0x3C);
            WriteByte(0xFF);
            WriteByte(0xFF);
            WriteByte(0xFF);
            WriteByte(0x3C);
          }    
        else  
          {
            // Sensor-ID ist nicht gespeichert
            WriteByte(0x00);
            WriteByte(0x00);
            WriteByte(0x00);
            WriteByte(0x00);
            WriteByte(0x00);
          }    
      }
  }

void W1SearchNewSensor(void)
  {
    unsigned char W1_Buffer[7];
    unsigned char Ende;
    unsigned char *Adress;
    
    // Anzeige lschen
    ClearScreen();
    
    for(i=0;i<8;i++)
      {
        W1_Buffer[i]=0;
      }

    LastDiscrepancy=0;
    do
      {
        W1_ROM_Search(W1_Buffer);

        Ende=0;
        Adress=EEProm+SensorAddress;
        while (Adress<EEProm+SensorAddressEnd||Ende==1)
          {
            if (ReadEEProm(Adress)!=0x00)                 
              {
                // Sensor-ID ist nicht gelscht
                for(i=0;i<8;i++)
                  {
                    if (ReadEEProm(Adress)!=W1_Buffer[i])
                      {
                        Ende=1;
                      }  
                    Adress++;
                  }
              }    
          }
          
        if (Ende==1)
          {
            // 1-Wire-ID anzeigen
            for(i=8;i>0;i--)
              {
                puts(" ");
                puts(Hex(W1_Buffer[i-1]));
              }
          }
      }
    while ((LastDiscrepancy>0) || Ende==1);
  }

// Ende Menfunktionen
//*****************************************************************************


//*****************************************************************************
// ENC28J60 Routinen
void Write_OP(unsigned char command, unsigned char address, unsigned char value)
  {
    CS_ETH=0;

    SendSPI(command | (address & ADDR_Mask));
    SendSPI(value);

    CS_ETH=1;
  }

unsigned char Read_OP(unsigned char command, unsigned char address)
  {
    unsigned char tmp;

    CS_ETH=0;

    SendSPI(command | (address & ADDR_Mask));
    tmp = ReadSPI();
    tmp = ReadSPI();

    CS_ETH=1;

    return tmp;
  }

void SetBank(unsigned char Bank)
  {
    if ((Bank & Bank_Mask)!=LastBank)
      {
        Write_OP(ENC28J60_BIT_FIELD_CLR, ECON1, ECON1_BSEL1|ECON1_BSEL0);
        Write_OP(ENC28J60_BIT_FIELD_SET, ECON1, (Bank & Bank_Mask)>>5);
        LastBank=(Bank & Bank_Mask);
      }
  }

void Write_Ctrl_Reg(unsigned char address, unsigned char value)
  {
    SetBank(address);
    Write_OP(ENC28J60_WRITE_CTRL_REG, address, value);
  }

unsigned char Read_Ctrl_Reg(unsigned char address)
  {
    SetBank(address);
    return Read_OP(ENC28J60_READ_CTRL_REG, address);
  }

void Write_PHY(unsigned char address, int value)
  {
    SetBank(MIREGADR);
    Write_OP(ENC28J60_WRITE_CTRL_REG, MIREGADR, address);
    Write_OP(ENC28J60_WRITE_CTRL_REG, MIWRL, value & 0xFF);
    Write_OP(ENC28J60_WRITE_CTRL_REG, MIWRH, (value >> 8) & 0xFF);
  }

int Read_PHY(unsigned char address)
  {
    int tmp;

    SetBank(MIREGADR);
    Write_OP(ENC28J60_WRITE_CTRL_REG, MIREGADR, address);
    Write_OP(ENC28J60_BIT_FIELD_SET, MICMD, MICMD_MIIRD);                      // PHY-Lesen
    while((Read_OP(ENC28J60_READ_CTRL_REG, MISTAT) & MISTAT_BUSY) == 1) {}     // Warten bis lesen zu Ende

    Write_OP(ENC28J60_BIT_FIELD_CLR, MICMD, MICMD_MIIRD);                      // PHY-Lesen-Ende

    tmp = Read_OP(ENC28J60_READ_CTRL_REG, MIRDH)*256 + Read_OP(ENC28J60_READ_CTRL_REG, MIRDL);
    return tmp;
  }

void InitNetwork(void)
  {
	// warten auf Ende des Power-On-Reset
	while(!(Read_Ctrl_Reg(ESTAT) & ESTAT_CLKRDY));
    // Softwarereset
   Write_OP(ENC28J60_SOFT_RESET, 0, ENC28J60_SOFT_RESET);
	Delay_50us();

	// set bank 0
	// initialize receive buffer
	// 16-bit transfers, must write low byte first
	// set receive buffer start address
	Write_Ctrl_Reg(ERXSTL, RXSTART_INIT&0xFF);
	Write_Ctrl_Reg(ERXSTH, RXSTART_INIT>>8);
	// set receive pointer address
	Write_Ctrl_Reg(ERXRDPTL, RXSTART_INIT&0xFF);
	Write_Ctrl_Reg(ERXRDPTH, RXSTART_INIT>>8);
	// set receive buffer end
	// ERXND defaults to 0x1FFF (end of ram)
	Write_Ctrl_Reg(ERXNDL, RXSTOP_INIT&0xFF);
	Write_Ctrl_Reg(ERXNDH, RXSTOP_INIT>>8);
	// set transmit buffer start
	// ETXST defaults to 0x0000 (beginnging of ram)
	Write_Ctrl_Reg(ETXSTL, TXSTART_INIT&0xFF);
	Write_Ctrl_Reg(ETXSTH, TXSTART_INIT>>8);

	// set bank 2
	// enable MAC receive
    Write_Ctrl_Reg(MACON1, 0x0D);
	// bring MAC out of reset
	Write_Ctrl_Reg(MACON2, 0x00);
	// enable automatic padding and CRC operations
	Write_Ctrl_Reg(MACON3, 0x32);

	// set inter-frame gap (non-back-to-back)
	Write_Ctrl_Reg(MAIPGL, 0x12);
	Write_Ctrl_Reg(MAIPGH, 0x0C);
	// set inter-frame gap (back-to-back)
	Write_Ctrl_Reg(MABBIPG, 0x12);
	// Set the maximum packet size which the controller will accept
	Write_Ctrl_Reg(MAMXFLL, MAX_FRAMELEN&0xFF);
	Write_Ctrl_Reg(MAMXFLH, MAX_FRAMELEN>>8);

	// set bank 3
	// write MAC address
	// NOTE: MAC address in ENC28J60 is byte-backward
	Write_Ctrl_Reg(MAADR5, ENC28J60_MAC0);
	Write_Ctrl_Reg(MAADR4, ENC28J60_MAC1);
	Write_Ctrl_Reg(MAADR3, ENC28J60_MAC2);
	Write_Ctrl_Reg(MAADR2, ENC28J60_MAC3);
	Write_Ctrl_Reg(MAADR1, ENC28J60_MAC4);
	Write_Ctrl_Reg(MAADR0, ENC28J60_MAC5);

	// no loopback of transmitted frames
	Write_PHY(PHCON2, PHCON2_HDLDIS);

	// set bank 0
	SetBank(ECON1);
	// enable interrutps
	Write_Ctrl_Reg(EIE, 0xC0);
	// enable packet reception
	Write_Ctrl_Reg(ECON1, 0x04);

//    Write_PHY(PHLCON,0x0AB8);     // Beide LEDs langsam blinken (Gelb - Grn)
    Write_PHY(PHLCON,0x04A8);     // Link und schnelles blinken
  }
// Ende ENC28J60 Routinen
//*****************************************************************************

void InitSeriell (void)
{
   ES = 0;
   SCON=0x54;
   RCAP2L=0xDD;  // 38400 Baud wegen X2
   RCAP2H=0xFF;
   T2CON=0x34;
   PCON=PCON & 0x7F;   // SMOD=0
   ES = 1;
}


void main(void)
  {
    unsigned int i;
    unsigned char W1_Buffer[7];

    // InitRAM
    AUXR=AUXR | XRS2 & ~XRS1 & ~XRS0 & ~EXTRAM;   // interner RAM ist 1792 Byte gro und soll benutzt werden

    InitW1();
    
    InitSPI();
    InitIIC();

    InitStdOut();
    
    InitEEProm();
    
    InitSeriell();

    puts("Hallo Welt !!!");

//    InitNetwork();
    Write_PHY(PHLCON,0x04A8);     // Link und schnelles blinken

    for (i = 0; i <= 32766; i++) ;         // Verzgerung
    for (i = 0; i <= 32766; i++) ;         // Verzgerung
    puts(Hex(Read_PHY(PHID2)));
    puts("Fertig");
    puts(CStr(11973));
    puts(CStr(ReadTemperatur()));
    ConvertTemperatur();

    // Timer 0 initialisieren
    CKCON0=CKCON0 | T0X2;    // Takt fr Timer0 durch 12 teilen
//    CKCON0=CKCON0 & ~T0X2;   // Takt fr Timer0 durch 6 teilen
    TR0=0;                   // Zhler anhalten
    TMOD=TMOD & 0xF1;        // Mode 1
    TMOD=TMOD | 0x01;        // Mode 1
    TL0=0;
    TH0=120;
    TR0=1;                   // Zhler starten
    ET0=1;                   // Enable Interrupt Timer 0

    EA=1;

//    W1_Reset();
//    W1_Write_Byte(Read_ROM);
//    for(i=0;i<8;i++)
//      {
//        W1_Buffer[i]=W1_Read_Byte();
//      }

    for(i=0;i<8;i++)
      {
        W1_Buffer[i]=0;
      }

    LastDiscrepancy=0;
    do
      {
        W1_ROM_Search(W1_Buffer);

        for(i=0;i<8;i++)
          {
            puts(" ");
            puts(CStr(W1_Buffer[i]));
          }
        puts(CRLF);
      }
    while (LastDiscrepancy>0);

//    ToggleDS2405(W1_Buffer);

    puts(CStr(ReadEEProm(EEProm)));

    while (1)                                    // Schleife endlos
      {
        SBUF=0x55;
        while (TI==0);
        TI=0;


        LED1 = ON;                               // LED einschalten
        for (i = 0; i <= 32767; i++) {;}         // Verzgerung
        LED1 = OFF;                              // LED Ausschalten
        for (i = 0; i <= 32767; i++) {;}         // Verzgerung

        i=Taste;
        Taste=0;
        if (EditActive==1)
          {
            switch (i)
              {
                case Taste_OK:      SaveEditValue();
                                    break;
                case Taste_Abbruch: AbbortEdit();
                                    break;
                case Taste_Hoch:    IncEditValue();
                                    break;
                case Taste_Runter:  DecEditValue();
                                    break;
                case Taste_Hoch+Taste_Gehalten:    
                                    IncBigEditValue();
                                    break;
                case Taste_Runter+Taste_Gehalten:  
                                    DecBigEditValue();
                                    break;
              }                      
          }
         else
          {  
            switch (i)
              {
                case Taste_OK:      Menue_Set();
                                    break;
                case Taste_Abbruch: Menue_Back();
                                    break;
                case Taste_Hoch:    Menue_Down();
                                    break;
                case Taste_Runter:  Menue_Up();
                                    break;
              }
          }
      }
  }


void timer0_isr(void) __interrupt(1)
  {
    #define Zeit_Prellen 8
    #define Zeit_Gehalten 100
    #define Zeit_Wiederholung 50
    
    // Timer 0 Interrupt
    unsigned char i;
    unsigned char Zustand;

    Zustand=P0;
    for (i=0;i<AnzahlTasten;i++)
      {
        if ((Zustand & (1<<i))==0)
          {
            if (TastenZeit[i]<255) TastenZeit[i]++;
            if ((TastenZeit[i]==Zeit_Gehalten) | (TastenZeit[i]==Zeit_Gehalten+Zeit_Wiederholung))
              {
                Taste=i+1+Taste_Gehalten;                           // Taste ist jetzt 2s gedrckt
                TastenZeit[i]=Zeit_Gehalten;
              }
          }
         else
          {
            if ((TastenZeit[i]>Zeit_Prellen) & (TastenZeit[i]<Zeit_Gehalten)) Taste=i+1; // Taste war lnger als 125ms und krzer als 2s gedrckt
            TastenZeit[i]=0;
          }
      }

    TR0=0;                   // Zhler anhalten
    TL0=0;
    TH0=150;
    TR0=1;                   // Zhler starten
  }

void int0_isr(void) __interrupt(0)
  {

  }

void int1_isr(void) __interrupt(2)
  {

  }

void timer1_isr(void) __interrupt(3)
  {

  }

void serial_isr(void) __interrupt(4)
  {
//    SBUF=SBUF;
  }

void timer2_isr(void) __interrupt(5)
  {

  }

