//*****************************************************************************
// SPI-Routinen
#if SPI_Interface==1
void Delay_SPI(void)
  {
    _asm
    NOP
    _endasm;
  }
#endif

void InitSPI(void)
  {
    #if SPI_Interface==1
      SPI_CLK=0;
      SPI_DIN=0;
     #else
      CKCON0 = CKCON0 | X2;                        // CPU-Takt verdoppeln
      // SPI Takt ist fosc/2
      SPCON = SPEN | SSDIS | MSTR ;//| CPHA;       // SPI enabled, SS disabled, SPI Master
    #endif
  }

void SendSPI(unsigned char value)
  {
    #if SPI_Interface==1
      for (i=0;i<8;i++)
        {
          SPI_DIN=value & 0x80;
          Delay_SPI();
          SPI_CLK=1;
          Delay_SPI();
          SPI_CLK=0;
          Delay_SPI();
          value=value<<1;
        }
     #else
      // warten das die letzten Daten versendet wurden
      // Es wird vor dem Senden gewartet, damit whrend dem Senden andere Aufgaben erledigt werden knnen
      SPDAT = value;
      while (!(SPSTA & SPIF)) {}
    #endif
  }

unsigned char ReadSPI(void)
  {
    #if SPI_Interface==1
      return 0xFF;
     #else
      SPDAT = 0xFF;
      while (!(SPSTA & SPIF)) {}                   // warten das die Daten empfangen wurden

      return SPDAT;
    #endif
  }

// Ende SPI-Routinen
//*****************************************************************************
